#ifndef __JSMODULE_H
#define __JSMODULE_H

/*
this struct should be in every module under the name
xxxxxx_javascript_module, where xxxxxx is the filename of the module

*/
typedef struct {
	/* JSClass object to be inited
		* the name of the class is set to the filename, no need to set
	*/
	JSClass *js_class;

	/* init function to run, runned only if not NULL */
	JSObject *(*init_function)(JSContext *cx, JSObject *global_object);

	/* a list of modules that are needed to run this module, 
		ending with NULL, or NULL if this module only needs itself
	 */
	const char **needed_modules;

#if 1
	/* init function to call on start of the script
		runned only if not NULL
	*/
	void (*init_start)(JSContext *cx, JSObject *global_object);
#endif
}Javascript_module;

struct Module_handle;
struct Module_handle *get_module_handle(const char *module_name, Javascript_module *static_module);
JSObject *load_javascript_module(JSContext *cx, JSObject *obj, const char *module_name);
JSObject *JS_InitModuleClass(JSContext *cx, JSObject *obj);
void init_modules(void);

extern const char *javacsript_lib_dir;

#endif
