
/*

TODO...
* make include search through include directorys

*/

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <ctype.h>
#include <errno.h>

#include "mod_js_config.h"
#include "jssystem.h"
#include "jscache.h"



#ifdef JAVASCRIPT_APACHE_MODULE
static Mod_javascript_info *get_request_rec_from_context(JSContext *cx);
#endif

/*************************
system dependant stuff used by other modules....
*/

int system_setup_get_form_post_info(JSContext *cx,struct Get_form_post_info *this)
{
#ifdef JAVASCRIPT_APACHE_MODULE
	int r;
	GET_REQUEST_REC

	this->upto=NULL;
	if((r=ap_setup_client_block(mod_javascript_info->request,REQUEST_CHUNKED_ERROR))) { return r; }
	ap_should_client_block(mod_javascript_info->request);
	return OK;
#else
	return 0;
#endif
}

int system_getc_form_post(JSContext *cx,struct Get_form_post_info *this)
{
#ifdef JAVASCRIPT_APACHE_MODULE
	int len;
	GET_REQUEST_REC

	if(this->upto>=this->buf_end || this->upto==NULL) {
		len=ap_get_client_block(mod_javascript_info->request,this->buf,GET_FORM_POST_BUF_SIZE);
		if(len<=0) { return EOF; }
		this->upto=this->buf;
		this->buf_end=this->buf+len;
	}
	return *this->upto++;
#else
	return fgetc(stdin);
#endif
}

/*************************
useful stuff....
*/

#ifdef JAVASCRIPT_APACHE_MODULE
static Mod_javascript_info *get_request_rec_from_context(JSContext *cx)
{
	JSObject *global_object;

	global_object=JS_GetGlobalObject(cx);
	return JS_GetPrivate(cx,global_object);
}

/*
Process the header and put it into the apache request_rec
*/
void
process_http_header(Mod_javascript_info *info)
{
	char *value;
	char *header;
	request_rec *request;

	header=info->header;
	request=info->request;
	if((value=strchr(header,':'))==NULL) {
		JS_ReportError(info->cx,"Bad HTTP header: %s\n",info->header);
		return;
	}
	*value++=0;
	while(isspace(*value)) value++;
	if(strcasecmp("Content-Type",header)==0) {
		request->content_type=ap_pstrdup(request->pool,value);
	}
	else if(strcasecmp("Status",header)==0) {
		request->status=atoi(value);
		request->status_line=ap_pstrdup(request->pool,value);
	}
	else {
		ap_table_merge(request->err_headers_out,header,value);
	}
}


int check_end_of_headers_char(Mod_javascript_info *mod_javascript_info,int ch)
{
	if(ch == '\n') {
		if(mod_javascript_info->status&LAST_CHAR_WAS_LF) {
			ap_send_http_header(mod_javascript_info->request);
			ap_rputc('\n',mod_javascript_info->request);
			mod_javascript_info->status|=HTTP_HEADERS_SENT;
			return 1;
		}
		else {
			mod_javascript_info->header_upto[0]=0;
			process_http_header(mod_javascript_info);
			mod_javascript_info->header_upto=mod_javascript_info->header;

			mod_javascript_info->status|=LAST_CHAR_WAS_LF;
		}
	}
	else if(ch !='\r') {
		*mod_javascript_info->header_upto++=ch;
		mod_javascript_info->status&=-1^LAST_CHAR_WAS_LF;
	}
	return 0;
}
void check_end_of_headers_str(Mod_javascript_info *mod_javascript_info, const char *str)
{
	const char *s;
	for(s=str; *s; s++) {
		if(check_end_of_headers_char(mod_javascript_info,s[0])) {
			break;
		}
	}
}


#endif



/*************************
methods....
*/

static JSBool
system_writeln_err(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	JSString * str;
	int i;
	GET_REQUEST_REC

	for (i = 0; i < argc; i++) {
		if (JSVAL_IS_STRING(argv[i])) {
		    str = JSVAL_TO_STRING(argv[i]);
		}
		else {
		    str = JS_ValueToString(cx, argv[i]);
		    if (!str)
			return JS_FALSE;
		    argv[i] = STRING_TO_JSVAL(str);
		}
		fputs(JS_GetStringBytes(str),stderr);
	}
	fputs("\n",stderr);
	return JS_TRUE;
}


static JSBool
system_write(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	JSString * str;
	int i;
	GET_REQUEST_REC

	for (i = 0; i < argc; i++) {
		if (JSVAL_IS_STRING(argv[i])) {
		    str = JSVAL_TO_STRING(argv[i]);
		}
		else {
		    str = JS_ValueToString(cx, argv[i]);
		    if (!str)
			return JS_FALSE;
		    argv[i] = STRING_TO_JSVAL(str);
		}
		system_puts(JS_GetStringBytes(str));
	}
	return JS_TRUE;
}

static JSBool
system_writeln(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	GET_REQUEST_REC

	if(system_write(cx,obj,argc,argv,rval)==JS_TRUE) {
		system_putc('\n');
		return JS_TRUE;
	}
	return JS_FALSE;
}

static JSBool
flush_function(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	GET_REQUEST_REC

	system_flush();
	return JS_TRUE;
}


/******************
system stuff...
*/


#if ENABLE_SHELL_COMMANDS

/* run shell command and return file handle to read */
static int run_shell_cmd(JSContext *cx,JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	JSString * str;
	int i;
	char **exec_args;
	static char shell_program[]="/bin/sh";
	int pid;
	int out_pipe[2];
#ifdef JAVASCRIPT_APACHE_MODULE
	GET_REQUEST_REC

#endif
	if(pipe(out_pipe)<0) {
		JS_ReportError(cx,"Cannot create pipe: %s\n",sys_errlist[errno]);
		return JS_FALSE;
	}

	if((pid=fork())==0) {
		char *program;
		int exec_arg_upto;

		dup2(out_pipe[1],STDOUT_FILENO);
		close(out_pipe[0]);
		exec_args=malloc((argc+3)*sizeof(exec_args[0]));
		exec_arg_upto=0;
		exec_args[exec_arg_upto++]=shell_program;
		exec_args[exec_arg_upto++]="-c";
		for (i = 0; i < argc; i++) {
			if (JSVAL_IS_STRING(argv[i])) {
			    str = JSVAL_TO_STRING(argv[i]);
			}
			else {
			    str = JS_ValueToString(cx, argv[i]);
			    if (!str)
				return JS_FALSE;
			}
			exec_args[exec_arg_upto]=js_DeflateString(cx,str->chars,str->length);
			exec_arg_upto++;
		}
		program=exec_args[0];
		exec_args[exec_arg_upto]=NULL;
                execve(shell_program,exec_args,mod_js_environ());
		JS_ReportError(cx,"jssystem: exec failed: %s\n",program);
		exit(1);
	}
	close(out_pipe[1]);
	return out_pipe[0];
}


static JSBool
system_system(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	int wait_status;
	int fd;
	int buf_len;
	char buf[1024];
	GET_REQUEST_REC

	fd=run_shell_cmd(cx,obj,argc,argv,rval);
	/* output the stuff form the shell command */
	while((buf_len=read(fd,buf,sizeof(buf)-1))>0) {
		buf[buf_len]=0;
		system_puts(buf);
	}
	close(fd);

	wait(&wait_status);
	*rval=INT_TO_JSVAL(WEXITSTATUS(wait_status));

	return JS_TRUE;
}
#else

static JSBool
system_system(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	JS_ReportError(cx,"System.system not enabled on compile time\n");
	return JS_TRUE;
}

#endif



static JSBool
system_include(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	char *filename;

	if(argc>=1 && JSVAL_IS_STRING(argv[0])) {
		JSObject *global_obj;
		Cached_script *script;
		JSScript *scr;

		filename=JS_GetStringBytes(JSVAL_TO_STRING(argv[0]));
		global_obj=JS_GetGlobalObject(cx);
#if 0
/*~~~ use full filename to put into cache */
		script=get_or_make_cached_script(cx,filename);
		if(JS_CallFunctionName(cx,item->data.script,"exec",1,args,&return_val)==JS_FALSE) {
			JS_ReportError(cx,"Problem executing script from cache: %s\n",filename);
		}
#endif

		scr=JS_CompileFile(cx,global_obj,filename);
		return JS_ExecuteScript(cx,global_obj,scr,rval);
	}
	JS_ReportError(cx,"System.include: needs a filename\n");
	*rval=JSVAL_FALSE;
	return JS_TRUE;
}

/*******************/

static JSFunctionSpec static_system_methods[] = {
	{"write",		system_write,		0},
	{"writeln_err",		system_writeln_err,		0},
	{"writeln",		system_writeln,		0},
	{"include",		system_include,		1},
	{"flush",		flush_function,		0},

	{"system",		system_system,		0},
	{NULL,NULL,0}
};


enum {
	TIMES_RUNNED=1,
};
static JSPropertySpec static_system_properties[]={
	{"times_runned",TIMES_RUNNED,JSPROP_READONLY},
	{0},
};

static JSBool get_system_property(JSContext *cx,JSObject *obj,jsval id, jsval *rval)
{
	Context_info *info;
	int id_num;

	id_num=JSVAL_TO_INT(id);
	*rval=JSVAL_VOID;
	switch(id_num) {
	case TIMES_RUNNED:
		if((info=JS_GetPrivate(cx,JS_GetGlobalObject(cx)))!=NULL) {
			*rval=INT_TO_JSVAL(info->cached_script->times_runned);
		}
		break;
	}
	return JS_TRUE;
}

/**************************/

static JSClass system_class = {
	"System",
	0,
	JS_PropertyStub,  JS_PropertyStub,  get_system_property,  JS_PropertyStub,
	JS_EnumerateStub, JS_ResolveStub,   JS_ConvertStub,   JS_FinalizeStub
};


static JSBool
System(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	return JS_TRUE;
}


JSObject *
JS_InitSystemClass(JSContext *cx, JSObject *obj)
{
	JSObject *proto;

	proto = JS_InitClass(cx, obj, NULL, &system_class, System, 0,
		NULL, NULL, static_system_properties, static_system_methods);
	if(proto==NULL) { return NULL; }
	return proto;
}



