#ifndef __JSSYSTEM_H
#define __JSSYSTEM_H

#ifdef JAVASCRIPT_APACHE_MODULE
#include "httpd.h"
#include "http_config.h"
#include "http_request.h"
#include "http_protocol.h"
#include "mod_js.h"

void process_http_header(Mod_javascript_info *info);

int check_end_of_headers_char(Mod_javascript_info *mod_javascript_info,int ch);
void check_end_of_headers_str(Mod_javascript_info *mod_javascript_info, const char *str);



#define system_putc(x) \
	if(!(mod_javascript_info->status&HTTP_HEADERS_SENT)) \
		check_end_of_headers_char(mod_javascript_info,x); \
	else ap_rputc(x,mod_javascript_info->request);

#define system_puts(x) \
	if(!(mod_javascript_info->status&HTTP_HEADERS_SENT)) \
		check_end_of_headers_str(mod_javascript_info,x); \
	else ap_rputs(x,mod_javascript_info->request);

#define system_flush() ap_rflush(mod_javascript_info->request)

#define GET_REQUEST_REC Mod_javascript_info *mod_javascript_info; \
	mod_javascript_info=get_request_rec_from_context(cx); \

#else
#define system_putc(x) fputc(x,stdout)
#define system_puts(x) fputs(x,stdout)
#define system_flush() fflush(stdout)
#define GET_REQUEST_REC

#endif




/* used in Cgi
 * will get from stdin if in jsh
 * will get from client if in apache module
*/

#define GET_FORM_POST_BUF_SIZE 1024
#define SETUP_GET_FORM_POST \
	struct Get_form_post_info form_post_info; \
	form_post_info.upto=NULL; \
	system_setup_get_form_post_info(cx,&form_post_info);

struct Get_form_post_info {
	char buf[GET_FORM_POST_BUF_SIZE];
	char *upto;
	char *buf_end;
};


#define getc_form_post() system_getc_form_post(cx,&form_post_info);

int system_getc_form_post(JSContext *cx,struct Get_form_post_info *this);
int system_setup_get_form_post_info(JSContext *cx,struct Get_form_post_info *this);


struct Mod_javascript_info;
JSObject * JS_InitSystemClass(JSContext *cx, JSObject *obj);

extern const char *mod_js_getenv (const char *name);
extern int mod_js_setenv (const char *name, const char *value, int overwrite);
extern void mod_js_env_do(int (*comp) (void *, const char *, const char *), void *rec);
extern const char **mod_js_environ (void);

#endif
