/* Desc: Stuff to handle cgis
TODO...

* multipart forms

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <mod_js_config.h>
#include "jssystem.h"


static jsval url_decode;

static JSBool add_UC_name_value_pair(JSContext *cx,JSObject *obj,
	jschar *encoded_name,int encoded_name_len,
	jschar *encoded_value,int encoded_value_len)
{
	jsval decode_argv[1];
	JSString *dummy_string;
	jsval array_jsval;
	jsint array_length;
	jsval decoded_name_jsval;
	jsval value;
	JSString *decoded_name;
	JSObject *array;

	dummy_string=JS_NewUCStringCopyN(cx,encoded_name,encoded_name_len);
	decode_argv[0]=STRING_TO_JSVAL(dummy_string);
	JS_CallFunctionValue(cx,obj,url_decode,1,decode_argv,
		&decoded_name_jsval);
	decoded_name=JSVAL_TO_STRING(decoded_name_jsval);

	if(JS_GetUCProperty(cx,obj,decoded_name->chars,
	 decoded_name->length,&array_jsval)==JS_FALSE) {
		return JS_FALSE;
	}
	else if(JSVAL_IS_VOID(array_jsval)) {
		/* make a new array */
		array=JS_NewArrayObject(cx,0,NULL);
		array_jsval=OBJECT_TO_JSVAL(array);
		JS_SetUCProperty(cx,obj,
			decoded_name->chars,decoded_name->length,
			&array_jsval);
	}
	else { array=JSVAL_TO_OBJECT(array_jsval); }

	/* add property to array */
	if(encoded_value!=NULL && encoded_value_len!=0) {
		dummy_string=JS_NewUCStringCopyN(cx,encoded_value,encoded_value_len);
		decode_argv[0]=STRING_TO_JSVAL(dummy_string);

		JS_CallFunctionValue(cx,obj,url_decode,1,decode_argv,
			&value);
	}
	else {
		/* no value */
		value=JSVAL_TRUE;
	}


	JS_GetArrayLength(cx,array,&array_length);
	if(JS_SetElement(cx,array,array_length,&value)!=JS_TRUE) {
		return JS_FALSE;
	}

	return JS_TRUE;
}

static JSBool
add_query(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	JSString *encoded_query;
	jschar *encoded,*encoded_end,*encoded_name,*encoded_value;

	if(!JSVAL_IS_STRING(argv[0])) {
		/* not a string nothing todo */
		return JS_TRUE;
	}

	encoded_query=JSVAL_TO_STRING(argv[0]);
	if(encoded_query->length<=0) {
		/* empty string, nothing todo */
		return JS_TRUE;
	}
	encoded=encoded_query->chars;
	encoded_end=encoded+encoded_query->length;
	encoded_name=encoded;
	encoded_value=NULL;

	for(; ; encoded++) {
		int ch;
		int name_len;

		ch=*encoded;
		if(encoded<encoded_end) {
			if(ch=='=') { encoded_value=encoded; continue; }
			if(ch!='&') {
				continue;
			}
		}

		if(encoded_value!=NULL) {
			name_len=encoded_value-encoded_name;
		}
		else { name_len=encoded-encoded_name; }
		if(encoded_value!=NULL) { encoded_value++; }
		add_UC_name_value_pair(cx,obj,encoded_name,
			name_len,encoded_value,
			encoded-encoded_value
			);


		encoded_name=encoded+1;
		encoded_value=NULL;
		if(encoded>=encoded_end) { break; }
	}

	return JS_TRUE;
}

#define MIME_TYPE_URL_ENCODED_FORM "application/x-www-form-urlencoded"
#define MIME_TYPE_MULTIPART_FORM "multipart/form-data"

static JSBool
get_post(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	/* get post from stdin */
	int ch;
	const char *content_type;
	SETUP_GET_FORM_POST

	content_type=getenv("CONTENT_TYPE");
	if(strncmp(content_type,MIME_TYPE_URL_ENCODED_FORM,sizeof(MIME_TYPE_URL_ENCODED_FORM)-1)==0) {
		jschar name[4096];
		jschar value[4096];
		jschar *name_upto,*value_upto;
		int within_value=0;

		name_upto=name; value_upto=value;
		while(1) {
			ch=getc_form_post();
			if(ch=='&' || ch==EOF) {
				if((name_upto-name)>0
				 && add_UC_name_value_pair(cx,obj,
				 name,name_upto-name,
				 value,value_upto-value)!=JS_TRUE) {
					return JS_FALSE;
				}
				if(ch==EOF) { break; }

				within_value=0;
				name_upto=name; value_upto=value;
				continue;
			}
			else if(ch=='=') {
				within_value=1;
				continue;
			}
			if(within_value) { 
				if(value_upto<(value+sizeof(value)-1)) {
					*value_upto++=ch;
				}
			}
			else if(name_upto<(name+sizeof(value)-1)) {
				*name_upto++=ch;
			}
		}
	}
	else if(strncmp(content_type,MIME_TYPE_MULTIPART_FORM,sizeof(MIME_TYPE_MULTIPART_FORM)-1)==0) {
		/* find boundary */
		const char *boundary,*boundary_upto;
		int within_header;
		int lfs_done;
		char name[4096];
		char *dest_name_upto;
		static const char *name_text="name=";
		const char *name_upto;
		char *dest_binary,*dest_binary_end,*dest_binary_upto;
		int name_uses_quotes;

		if((boundary=strstr(content_type,"boundary="))==NULL) {
			JS_ReportError(cx,"Cannot find boundary from multipart post\n");
			return JS_TRUE;
		}
		boundary+=9;
		boundary_upto=boundary;
		within_header=0;
		name_upto=name_text;
		lfs_done=0;
		dest_name_upto=name;
		dest_binary=dest_binary_upto=dest_binary_end=NULL;
		name[0]=0;
		while(1) {
			ch=getc_form_post();
			if(within_header) {
				/* find name of this item */
				if(*name_upto!=0) {
					if(tolower(ch)==*name_upto) { 
						name_upto++; 
						continue; 
					}
					if(ch=='\n') {
						if(++lfs_done>2) { within_header=0; lfs_done=0; }
					}
					else if(ch!='\r') { lfs_done=0; }
				}
				/* name found */
				if(ch=='\"') {
					if(dest_name_upto==name) {
						name_uses_quotes=1;
					}
					else if(name_uses_quotes) {
						*dest_name_upto=0;
						name_upto=name_text;
					}
					continue;
				}
				else if(!name_uses_quotes && isspace(ch)) {
					*dest_name_upto=0; name_upto=name_text;
					continue;
				}
				if(dest_name_upto==name) {
					name_uses_quotes=0;
				}
				*dest_name_upto++=ch;
			}
			else {
				if(*boundary_upto==0) {
					if(ch=='\n') {
						if(name[0]!=0) {
							/*~~~ store into binary object */
						}
						dest_binary=dest_binary_upto=dest_binary_end=NULL;
						boundary_upto=boundary;
						within_header=1;
						name[0]=0;
					}
					else if(ch=='-') {
/* ~~~ last boundary? */
					}
					else if(ch!='\r') {
						boundary_upto=boundary;
					}
					continue;
				}
				if(*boundary_upto==ch) { boundary_upto++; }

				/* store post into binary format */
				if(dest_binary_upto>=dest_binary_end) {
					/* get more memory */
					int len,old_len;
					old_len=(dest_binary_end-dest_binary);
					if(len==0) { len=32; old_len=0; }
					else { len=old_len*2; }
					if(dest_binary==NULL) {
						dest_binary=JS_malloc(cx,len);
					}
					else {
						dest_binary=JS_realloc(cx,dest_binary,len);
					}
					dest_binary_upto=dest_binary+old_len;
					dest_binary_end=dest_binary+len;
				}
				*dest_binary_upto++=ch;
			}
		}
	}
	return JS_TRUE;
}


/**************/

static JSFunctionSpec cgi_methods[] = {
	{"add_query",		add_query,		0},
	{"get_post",		get_post,		0},
	{NULL,NULL,0}
};

static JSClass cgi_class = {
	NULL,
	0,
	JS_PropertyStub,  JS_PropertyStub,  JS_PropertyStub,  JS_PropertyStub,
	JS_EnumerateStub, JS_ResolveStub,   JS_ConvertStub,   JS_FinalizeStub
};


static JSBool
Cgi(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	*rval=OBJECT_TO_JSVAL(obj);
	return JS_TRUE;
}


static JSObject *
InitCgiModule(JSContext *cx, JSObject *obj)
{
	JSObject *proto;
	jsval url_jsval;

	/* find url_encode method */
	JS_GetProperty(cx,JS_GetGlobalObject(cx),"Url",&url_jsval);
	JS_GetProperty(cx,JSVAL_TO_OBJECT(url_jsval),"decode",&url_decode);
	if(JSVAL_IS_VOID(url_decode)) {
		JS_ReportError(cx,"Cannot find Url.decode()\n");
		return NULL;
	}

	proto = JS_InitClass(cx, obj, NULL, &cgi_class,Cgi,0,
		NULL, cgi_methods, NULL, NULL);
	if (!proto) return NULL;


	return proto;
}

static const char *needed_modules[]={"Url",NULL};

Javascript_module Cgi_javascript_module={
	&cgi_class,
	&InitCgiModule,
	needed_modules,
};

