/* Desc: Stuff to read/write to the environment
Environment.xxxx


TODO...
* environment stack, push pop sets of environments for use when shelling out

*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <mod_js_config.h>
#include <jssystem.h>


 
 struct do_struct {
        JSContext *cx;
        JSObject *obj;
 };
 
 static int
 set_environment_do(void *tdo, const char *name, const char *value)
 {
        jsval val;
 
        val=STRING_TO_JSVAL(JS_NewStringCopyZ(((struct do_struct *)tdo)->cx,value));
        JS_SetProperty(((struct do_struct *)tdo)->cx,
                       ((struct do_struct *)tdo)->obj,name,&val);
        return 1;
 }

  static JSBool
  set_all_environment(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
  {
        struct do_struct tdo = { cx, obj };
 
        mod_js_env_do (set_environment_do, &tdo);
         return JS_TRUE;
  }
 



#if 0
/* set everything into the environment */
static JSBool
set_all_environment(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	const char **envUpto;
	extern const char **environ;
	const char *equal;

	for(envUpto=environ; envUpto[0]!=NULL; envUpto++) {
		char envNameZ[256];
		jsval val;

		if((equal=strchr(envUpto[0],'='))!=NULL) {
			strncpy(envNameZ,envUpto[0],(unsigned int)(equal-(envUpto[0])));
			envNameZ[equal-envUpto[0]]=0;
			equal++;
		}
		else { 
			equal="";
			strcpy(envNameZ,envUpto[0]);
		}
		val=STRING_TO_JSVAL(JS_NewStringCopyZ(cx,equal));
		JS_SetProperty(cx,obj,envNameZ,&val);
	}
	return JS_TRUE;
}
#endif



/* set something to the environment */
static JSBool set_environment_property(JSContext *cx, JSObject *obj,jsval id, jsval *val)
{
	char *name;

	if(JSVAL_IS_STRING(id)) {
		char *val_chars;
		jsval val_as_jsval;

		name=JS_GetStringBytes(JSVAL_TO_STRING(id));
		val_chars=JS_GetStringBytes(JSVAL_TO_STRING(*val));
		val_as_jsval=STRING_TO_JSVAL(JS_NewStringCopyZ(cx,val_chars));

		JS_SetProperty(cx,obj,name,&val_as_jsval);
                mod_js_setenv(name,val_chars,1);
		return JS_TRUE;
	}

	JS_ReportError(cx,"setenv: The environment name isn\'t a string\n");
	return JS_FALSE;
}

static JSClass environment_class = {
	NULL,
	0,
	JS_PropertyStub,  set_environment_property,  JS_PropertyStub,  JS_PropertyStub,
	JS_EnumerateStub, JS_ResolveStub,   JS_ConvertStub,   JS_FinalizeStub
};


static JSFunctionSpec environment_static_methods[] = {
	{"reset",		set_all_environment,		0},
	{NULL,NULL,0}
};



static JSObject *
InitEnvironmentModule(JSContext *cx, JSObject *obj)
{
	JSObject *proto;

	proto = JS_InitClass(cx, obj, NULL, &environment_class, NULL, 0,
		NULL, NULL, NULL, environment_static_methods);
	if (!proto) return NULL;
	set_all_environment(cx,proto,0,NULL,JSVAL_NULL);

	return proto;
}

static void init_script(JSContext *cx,JSObject *obj)
{
	set_all_environment(cx,obj,0,NULL,NULL);
}

Javascript_module Environment_javascript_module={
	&environment_class,
	&InitEnvironmentModule,
	NULL,
	&init_script,
};


