/* desc: file stuff
*/

#include <mod_js_config.h>
#include <unistd.h>
#include <sys/stat.h>
#include <errno.h>

/* make the directories needed to create this file */
static JSBool
make_directories_for_file(JSContext *cx,const char *filename)
{
	const char *f;
	char *d;
	char dirname[FILENAME_MAX];
	struct stat dir_stat;

	d=dirname;
	for(f=filename; *f; f++) {
		if(*f=='/' && f!=filename) {
			*d=0;
			if(stat(dirname,&dir_stat)!=0) {
				if(mkdir(dirname,0750)!=0) {
					JS_ReportError(cx,"make_directories_for_file: Cannot make dir: %s  (%s)\n",
						dirname,sys_errlist[errno]);
				}
			}
		}
		*d++=*f;
	}
	return JS_TRUE;
}

static JSBool
file_unlink(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	int c;
	for(c=0; c<argc; c++) {
		unlink(JS_GetStringBytes(JS_ValueToString(cx,argv[c])));
	}

	return JS_TRUE;
}


static JSFunctionSpec file_static_methods[] = {
	{"unlink",		file_unlink,		0},
	{NULL,NULL,0}
};

static JSClass file_class = {
	NULL,
	0,
	JS_PropertyStub,  JS_PropertyStub,  JS_PropertyStub,  JS_PropertyStub,
	JS_EnumerateStub, JS_ResolveStub,   JS_ConvertStub,   JS_FinalizeStub
};




static JSObject *
InitFileModule(JSContext *cx, JSObject *obj)
{
	JSObject *proto;

	proto = JS_InitClass(cx, obj, NULL, &file_class, NULL, 0,
		NULL, NULL, NULL, file_static_methods);
	if (!proto) return NULL;

	return proto;
}


Javascript_module File_javascript_module={
	&file_class,
	&InitFileModule,
	NULL,
};

