
/*
NGS compatiblilty stuff


TODO:
* JS_InitClass
	* prototype


*/

/*************/

/* info about an Ngs object */
typedef struct Ngs_object_context {
	JSClass *js_class;
	JSInterpPtr *interp;
	uintN constructor_args;
	JSNative constructor;
	JSPropertySpec *static_properties;
	JSFunctionSpec *static_functions;
	JSPropertySpec *object_properties;
	JSFunctionSpec *object_functions;
	JSErrorReporter error_reporter;
}Ngs_object_context;



/*************/

extern JS_PUBLIC_API(void)
JS_ReportError(JSContext *cx, const char *format, ...)
{
    va_list ap;

    va_start(ap, format);
    cx->vm->ctx->error_reporter(format, ap);
    va_end(ap);
}

JS_PUBLIC_API(JSErrorReporter)
JS_SetErrorReporter(JSContext *cx, JSErrorReporter er)
{
    JSErrorReporter older;

    older = cx->ctx->errorReporter;
    cx->ctx->errorReporter = er;
    return older;
}

extern JS_PUBLIC_API(void *)
JS_GetPrivate(JSContext *cx, JSObject *obj)
{
/*~~~ */
}

extern JS_PUBLIC_API(JSBool)
JS_SetPrivate(JSContext *cx, JSObject *obj, void *data)
{
/*~~~ */
}

void JS_CompileFile()
{
	int i;

  interp = create_interp ();
#if 0
      /* Save all remaining arguments to ARGS */
      js_type_make_array (interp, &args, argc - optind);

      for (i = 0; optind + i < argc; i++)
	js_type_make_string (interp, &args.u.array->data[i],
			     argv[optind + i], strlen (argv[optind + i]));

      js_set_var (interp, "ARGS", &args);
#endif

      if (!js_eval_file (interp, main_file))
	{
	  fprintf (stderr, "%s: evaluation of file `%s' failed:\n%s\n",
		   program, main_file, js_error_message (interp));
	  exit (1);
	}
    }

  js_destroy_interp (interp);
}

/*
 * Function to call method <method> from the object.  Function must return
 * JS_PROPERTY_FOUND if the method was found or JS_PROPERTY_UNKNOWN
 * otherwise.
 */
int ngs_method_proc(struct js_vm_st *vm,
				struct js_builtin_info_st *builtin_info,
				void *instance_context,
				JSSymbol method,
				struct js_node_st *result_return,
				struct js_node_st *args)
{
/*~~~ */
}

/*
 * Function to load and set property <property> of object.  If <set>
 * is true, property <property> should be set to value <node>.  Otherwise
 * function should return the value of property <property> in <node>.
 * Function must return JS_PROPERTY_FOUND if the property was found or
 * JS_PROPERTY_UNKNOWN otherwise.
 */
int ngs_property_proc(struct js_vm_st *vm,
				  struct js_builtin_info_st *builtin_info,
				  void *instance_context,
				  JSSymbol property, int set,
				  struct js_node_st *node)
{
	/*~~~ */
}

/* call the constructor */
void ngs_new_proc(struct js_vm_st *vm,
			      struct js_builtin_info_st *builtin_info,
			      struct js_node_st *args,
			      struct js_node_st *result_return)
{
	Ngs_object_instance *object_instance;
	Ngs_object_context *obj_context;

	object_context=((Ngs_object_context *)(builtin_info->ctx));
	object_instance=js_malloc(vm,sizeof(*object_instance));
	object_instance->builtin_info=builtin_info;
	object_instance->private_info=NULL;
	js_vm_builtin_create(vm,result_return,builtin_info,object_instance);
	object_intance->object=u.vobject;
}


/* run the object's finalizer */
void ngs_delete_proc(struct js_builtin_info_st *builtin_info,
				 void *instance_context)
{
	Ngs_object_context *obj_context;
	obj_context=((Ngs_object_context *)(builtin_info->ctx));
	obj_context->js_class->finalize(obj_context->interp,instance_context);
	if(instance_context) { js_free(intance_context); }
}




JSObject *
JS_InitClass(JSContext *cx, JSObject *obj, JSObject *parent_proto,
	     JSClass *clasp, JSNative constructor, uintN nargs,
             JSPropertySpec *ps, JSFunctionSpec *fs,
             JSPropertySpec *static_ps, JSFunctionSpec *static_fs)
{
  JSBuiltinInfo *info;
  Ngs_object_context *ctx;
  JSNode *n;
  JSVirtualMachine *vm = interp->vm;

  ctx = js_calloc (vm, 1, sizeof (*ctx));
  memset(ctx,0,sizeof(*ctx));
  ctx->js_class=clasp;
  ctx->interp=cx;
  ctx->constructor=constructor;
  ctx->constructor_args=nargs;
  ctx->object_properties=ps;
  ctx->object_functions=fs;
  ctx->static_properties=static_ps;
  ctx->static_functinos=statis_fs;

  /* Object information. */

  info = js_vm_builtin_info_create (vm);

  info->method_proc		= ngs_method_proc;
  info->property_proc		= ngs_property_proc;
  info->new_proc		= ngs_new_proc;
  info->delete_proc		= ngs_delete_proc;
  info->obj_context		= ctx;
  info->obj_context_delete	= js_free;

  /* Define it. */
  n = &vm->globals[js_vm_intern (vm, clasp->name)];
  js_vm_builtin_create (vm, n, info, NULL);
}


